Index: LMDZ6/branches/LMDZ_ECRad/libf/misc/strings_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/misc/strings_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/misc/strings_mod.F90	(revision 4482)
@@ -789,4 +824,5 @@
   REAL, OPTIONAL, TARGET, DIMENSION(:), INTENT(IN) :: r1, r2, r3, r4, r5, r6, r7, r8, r9
   REAL, ALLOCATABLE :: out(:,:)
+!------------------------------------------------------------------------------------------------------------------------------
   REAL, POINTER     :: r(:)
   LOGICAL :: lv(10)
@@ -811,4 +847,5 @@
   DOUBLE PRECISION, OPTIONAL, TARGET, INTENT(IN) :: d1, d2, d3, d4, d5, d6, d7, d8, d9
   DOUBLE PRECISION, ALLOCATABLE :: out(:)
+!------------------------------------------------------------------------------------------------------------------------------
   DOUBLE PRECISION, POINTER     :: d
   LOGICAL :: lv(10)
@@ -830,4 +867,5 @@
   DOUBLE PRECISION, OPTIONAL, TARGET, DIMENSION(:), INTENT(IN) :: d1, d2, d3, d4, d5, d6, d7, d8, d9
   DOUBLE PRECISION, ALLOCATABLE :: out(:,:)
+!------------------------------------------------------------------------------------------------------------------------------
   DOUBLE PRECISION, POINTER     :: d(:)
   LOGICAL :: lv(10)
@@ -869,5 +907,5 @@
   INTEGER,          OPTIONAL, INTENT(IN)  :: unit          !--- Output unit (default: screen)
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: sub           !--- Subroutine name
-
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=2048) :: row
   CHARACTER(LEN=maxlen)  :: rFm, el, subn
@@ -879,5 +917,4 @@
   INTEGER, PARAMETER   :: nm=1                             !--- Space between values & columns
   LOGICAL :: ls, li, lr
-
   subn = '';    IF(PRESENT(sub)) subn = sub
   rFm = '*';    IF(PRESENT(rFmt)) rFm = rFmt               !--- Specified format for reals
@@ -954,5 +991,5 @@
       nr = LEN_TRIM(row)-1                                           !--- Final separator removed
       CALL msg(row(1:nr), subn, unit=unt)
-      IF(ir /= 1) CYCLE                                              !--- Titles are underlined
+      IF(ir /= 1) CYCLE                                              !--- Titles only are underlined
       row=''; DO ic=1,nHd; row=TRIM(row)//REPEAT('-',n(ic))//'+'; END DO
       DO ic = ib,ncmx(it); row=TRIM(row)//REPEAT('-',n(ic))//'+'; END DO
@@ -975,5 +1012,5 @@
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: rFmt          !--- Format for reals
   LOGICAL,          OPTIONAL, INTENT(IN)  :: llast         !--- Last variable: no final ','
-
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen)  :: rFm, el
   CHARACTER(LEN=maxlen), ALLOCATABLE :: d(:,:)
@@ -983,6 +1020,4 @@
   INTEGER, ALLOCATABLE :: n(:)
   LOGICAL :: ls, li, lr, la
-
-!  modname = 'dispNamelist'
   rFm = '*';    IF(PRESENT(rFmt)) rFm = rFmt               !--- Specified format for reals
   ls = PRESENT(s); li = PRESENT(i); lr = PRESENT(r)
@@ -1056,5 +1091,4 @@
   REAL,                       INTENT(IN)  ::  a(:)                   !--- Linearized array of values
   INTEGER,                    INTENT(IN)  ::  n(:)                   !--- Profile before linearization
-
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN)  :: err_msg, nam(:), subn   !--- Error message, variables and calling subroutine names
   INTEGER,          OPTIONAL, INTENT(IN)  :: nRowMax                 !--- Maximum number of lines to display    (default: all)
@@ -1062,4 +1096,5 @@
   INTEGER,          OPTIONAL, INTENT(IN)  :: nHead                   !--- Number of front columns to duplicate  (default: 1)
   INTEGER,          OPTIONAL, INTENT(IN)  :: unit                    !--- Output unit                           (def: lunout)
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen),      ALLOCATABLE :: ttl(:)
   LOGICAL,                    ALLOCATABLE :: m(:)
@@ -1139,10 +1174,9 @@
   INTEGER,          OPTIONAL, INTENT(IN)  :: nHead                   !--- Number of front columns to duplicate  (default: 1)
   INTEGER,          OPTIONAL, INTENT(IN)  :: unit                    !--- Output unit                           (def: lunout)
-
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen)                   :: mes, sub, fm='(f12.9)', prf
   CHARACTER(LEN=maxlen),      ALLOCATABLE :: ttl(:), vnm(:)
-  LOGICAL,                    ALLOCATABLE :: m(:)
   INTEGER,                    ALLOCATABLE :: ki(:), kj(:), kl(:)
-  INTEGER                                 :: i, j, k, rk, ib, ie, itr, nm, nv, unt, nRmx, nCmx, nHd, rk1
+  INTEGER                                 :: i, j, k, rk, nv, unt, nRmx, nCmx, nHd
   REAL,                       ALLOCATABLE :: val(:,:)
 
@@ -1160,5 +1194,5 @@
   lerr= SIZE(a,1) /= PRODUCT(n); IF(fmsg('profile "n" does not match "a" and "ll"', sub, lerr, unt)) RETURN
 
-  SELECT CASE(rk1)                                                   !--- Indices list
+  SELECT CASE(rk)                                                   !--- Indices list
     CASE(0); IF(ll(1)) THEN; WRITE(unt,'(a,", ",a," = ",2f12.9)')TRIM(vnm(1)),TRIM(vnm(2)),a(1,1),a(1,2); RETURN; END IF
     CASE(1); ki = [  (i,i=1,n(1)) ]
@@ -1189,5 +1223,5 @@
   CHARACTER(LEN=*),      INTENT(IN)  :: str
   CHARACTER(LEN=maxlen), INTENT(OUT) :: val
-
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen)              :: v
   CHARACTER(LEN=1024)                :: s, vv
@@ -1196,5 +1230,4 @@
   INTEGER :: nl, nn, i, j, im, ix
   LOGICAL :: ll
-!  modname = 'reduceExpr_1'
   s = str
 
@@ -1243,15 +1276,13 @@
   CHARACTER(LEN=maxlen), ALLOCATABLE :: ky(:)
   CHARACTER(LEN=1),      ALLOCATABLE :: op(:)
-
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=1024) :: s
   DOUBLE PRECISION :: v, vm, vp
   INTEGER      :: i, ni, io
-
-!  modname = 'reduceExpr_basic'
   lerr = .FALSE.
   IF(is_numeric(str)) THEN; val=TRIM(str); RETURN; END IF
   op = ['^','/','*','+','-']                                                   !--- List of recognized operations
   s = str
-  IF(test(strParse_m(s, op, ky, .TRUE., id = id), lerr)) RETURN                !--- Parse the values
+  IF(test(strParse_m(s, op, ky, lSc=.TRUE., id = id), lerr)) RETURN            !--- Parse the values
   vl = str2dble(ky)                                                            !--- Conversion to doubles
   lerr = ANY(vl >= HUGE(1.d0))
@@ -1262,10 +1293,10 @@
       IF(id(i) /= io) CYCLE                                                    !--- Current found operator is not op(io)
       vm = vl(i); vp = vl(i+1)                                                 !--- Couple of values used for current operation
-      SELECT CASE(io)                                                          !--- Perform operation on the two values
-        CASE(1); v = vm**vp  !--- ^
-        CASE(2); v = vm/vp   !--- /
-        CASE(3); v = vm*vp   !--- *
-        CASE(4); v = vm+vp   !--- +
-        CASE(5); v = vm-vp   !--- +
+      SELECT CASE(op(io))                                                          !--- Perform operation on the two values
+        CASE('^'); v = vm**vp
+        CASE('/'); v = vm/vp
+        CASE('*'); v = vm*vp
+        CASE('+'); v = vm+vp
+        CASE('-'); v = vm-vp
       END SELECT
       IF(i == ni) THEN; vl = [vl(1:ni-1), v]; ELSE; vl = [vl(1:i-1), v, vl(i+2:ni+1)]; END IF
@@ -1283,4 +1314,5 @@
   CHARACTER(LEN=*),                   INTENT(IN)  :: str(:)
   CHARACTER(LEN=maxlen), ALLOCATABLE, INTENT(OUT) :: val(:)
+!------------------------------------------------------------------------------------------------------------------------------
   INTEGER :: i
   ALLOCATE(lerr(SIZE(str)),val(SIZE(str)))
@@ -1302,5 +1334,4 @@
   READ(str,fmt,IOSTAT=e) x
   out = e==0 .AND. INDEX('Ee',str(LEN_TRIM(str):LEN_TRIM(str)))==0
-  IF(str == '') out = .FALSE.
 END FUNCTION is_numeric
 !==============================================================================================================================
@@ -1348,4 +1379,5 @@
   INTEGER,           INTENT(IN) :: i
   INTEGER, OPTIONAL, INTENT(IN) :: nDigits
+!------------------------------------------------------------------------------------------------------------------------------
   WRITE(out,*)i
   out = ADJUSTL(out)
@@ -1357,4 +1389,5 @@
   REAL,                       INTENT(IN) :: r
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fmt
+!------------------------------------------------------------------------------------------------------------------------------
   IF(     PRESENT(fmt)) WRITE(out,fmt)r
   IF(.NOT.PRESENT(fmt)) WRITE(out, * )r
@@ -1365,4 +1398,5 @@
   DOUBLE PRECISION,           INTENT(IN) :: d
   CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: fmt
+!------------------------------------------------------------------------------------------------------------------------------
   IF(     PRESENT(fmt)) WRITE(out,fmt)d
   IF(.NOT.PRESENT(fmt)) WRITE(out, * )d
@@ -1385,4 +1419,5 @@
 !==============================================================================================================================
 
+
 !==============================================================================================================================
 FUNCTION addQuotes_1(s) RESULT(out)
@@ -1395,4 +1430,5 @@
   CHARACTER(LEN=*), INTENT(IN)  :: s(:)
   CHARACTER(LEN=:), ALLOCATABLE :: out(:)
+!------------------------------------------------------------------------------------------------------------------------------
   INTEGER :: k, n
   n = MAXVAL(LEN_TRIM(s), MASK=.TRUE.)
@@ -1406,27 +1442,9 @@
   CHARACTER(LEN=*), INTENT(IN) :: s
   CHARACTER(LEN=1) :: b, e
+!------------------------------------------------------------------------------------------------------------------------------
   out = .TRUE.; IF(TRIM(s) == '') RETURN
   b = s(1:1); e = s(MAX(1,LEN_TRIM(s)):MAX(1,LEN_TRIM(s)))
   out = .NOT.is_numeric(s) .AND. (b /= "'" .OR. e /= "'") .AND. ( b /= '"' .OR. e /= '"')
 END FUNCTION needQuotes
-!==============================================================================================================================
-
-
-!==============================================================================================================================
-!=== TEST WHETHER A FILE IS PRESENT OR NOT ====================================================================================
-!==============================================================================================================================
-LOGICAL FUNCTION testFile_1(fname) RESULT(out)
-  CHARACTER(LEN=*), INTENT(IN) :: fname
-  INTEGER :: ierr
-  OPEN(90, FILE=fname, FORM='formatted', STATUS='old', IOSTAT=ierr); CLOSE(99)
-  out = ierr/=0
-END FUNCTION testFile_1
-!==============================================================================================================================
-FUNCTION testFile_m(fname) RESULT(out)
-  LOGICAL,         ALLOCATABLE ::   out(:)
-  CHARACTER(LEN=*), INTENT(IN) :: fname(:)
-  INTEGER :: k
-  out = [(testFile_1(fname(k)), k=1, SIZE(fname))]
-END FUNCTION testFile_m
 !==============================================================================================================================
 
@@ -1442,4 +1460,5 @@
   CHARACTER(LEN=*),   INTENT(IN)  :: message, items, reason
   INTEGER,  OPTIONAL, INTENT(IN)  :: nmax
+!------------------------------------------------------------------------------------------------------------------------------
   CHARACTER(LEN=maxlen), ALLOCATABLE :: s(:)
   INTEGER :: i, nmx
@@ -1464,4 +1483,3 @@
 
 
-
 END MODULE strings_mod
Index: LMDZ6/branches/LMDZ_ECRad/libf/misc/wxios.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/misc/wxios.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/misc/wxios.F90	(revision 4482)
@@ -308,4 +308,8 @@
         IF (xios_is_valid_axis("axis_lat")) THEN
            CALL xios_set_axis_attr( "axis_lat", n_glo=nbp_lat, n=jj_nb, begin=jj_begin-1, value=io_lat(jj_begin:jj_end))
+        ENDIF
+        IF (xios_is_valid_axis("axis_lat_greordered")) THEN
+           CALL xios_set_axis_attr( "axis_lat_greordered", n_glo=nbp_lat, n=jj_nb, begin=jj_begin-1, &
+                                    value=io_lat(jj_begin:jj_end)*(-1.))
         ENDIF
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phy_common/abort_physic.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phy_common/abort_physic.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phy_common/abort_physic.F90	(revision 4482)
@@ -38,4 +38,11 @@
       if (ierr .eq. 0) then
         write(lunout,*) 'Everything is cool'
+#ifdef CPP_MPI
+        !$OMP CRITICAL (MPI_ABORT_PHYSIC)
+        call MPI_ABORT(COMM_LMDZ_PHY, 0, ierror_mpi)
+        !$OMP END CRITICAL (MPI_ABORT_PHYSIC)
+#else
+        stop 0
+#endif          
       else
         write(lunout,*) 'Houston, we have a problem, ierr = ', ierr
Index: LMDZ6/branches/LMDZ_ECRad/libf/phy_common/physics_distribution_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phy_common/physics_distribution_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phy_common/physics_distribution_mod.F90	(revision 4482)
@@ -13,5 +13,5 @@
   USE mod_grid_phy_lmdz, ONLY: init_grid_phy_lmdz
   USE dimphy, ONLY : Init_dimphy
-  USE infotrac_phy, ONLY : types_trac
+  USE infotrac_phy, ONLY : type_trac
 #ifdef REPROBUS
   USE CHEM_REP, ONLY : Init_chem_rep_phys
@@ -39,6 +39,5 @@
 #ifdef REPROBUS
 ! Initialization of Reprobus
-    IF (ANY(types_trac == 'repr')) CALL Init_chem_rep_phys(klon_omp,nbp_lev)
-    END IF
+    IF (type_trac == 'repr') CALL Init_chem_rep_phys(klon_omp,nbp_lev)
 #endif
 
@@ -51,5 +50,5 @@
 !  USE mod_grid_phy_lmdz, ONLY: Init_grid_phy_lmdz!, nbp_lev
 !  USE dimphy, ONLY : Init_dimphy
-!  USE infotrac_phy, ONLY : types_trac
+!  USE infotrac_phy, ONLY : type_trac
 !#ifdef REPROBUS
 !  USE CHEM_REP, ONLY : Init_chem_rep_phys
@@ -72,5 +71,5 @@
 !#ifdef REPROBUS
 !! Initialization of Reprobus
-!    IF (ANY(types_trac == 'repr')) CALL Init_chem_rep_phys(klon_omp,nbp_lev)
+!    IF (type_trac == 'repr') CALL Init_chem_rep_phys(klon_omp,nbp_lev)
 !    END IF
 !#endif
Index: LMDZ6/branches/LMDZ_ECRad/libf/phy_common/vertical_layers_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phy_common/vertical_layers_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phy_common/vertical_layers_mod.F90	(revision 4482)
@@ -15,8 +15,10 @@
    REAL,SAVE,ALLOCATABLE :: presnivs(:) ! reference pressure at mid-layer (Pa),
                                         ! based on preff, ap and bp
+   REAL,SAVE,ALLOCATABLE :: presinter(:) ! reference pressure at interface (Pa),
+                                        ! based on preff, ap and bp
    REAL,SAVE,ALLOCATABLE :: pseudoalt(:) ! pseudo-altitude of model layers (km),
                                          ! based on preff and scaleheight
    
-!$OMP THREADPRIVATE(preff,scaleheight,ap,bp,aps,bps,presnivs,pseudoalt)
+!$OMP THREADPRIVATE(preff,scaleheight,ap,bp,aps,bps,presnivs,presinter,pseudoalt)
 
 
@@ -24,5 +26,5 @@
 
   SUBROUTINE init_vertical_layers(nlayer,preff_,scaleheight_,ap_,bp_,&
-                                 aps_,bps_,presnivs_, pseudoalt_)
+                                 aps_,bps_,presnivs_, presinter_, pseudoalt_)
     IMPLICIT NONE
     INTEGER,INTENT(IN) :: nlayer ! number of atmospheric layers
@@ -34,4 +36,5 @@
     REAL,INTENT(IN)    :: bps_(nlayer) ! hybrid coordinate at mid-layer
     REAL,INTENT(IN)    :: presnivs_(nlayer) ! Appproximative pressure of atm. layers (Pa)
+    REAL,INTENT(IN)    :: presinter_(nlayer+1) ! Appproximative pressure of atm. layers (Pa)
     REAL,INTENT(IN)    :: pseudoalt_(nlayer) ! pseudo-altitude of atm. layers (km)
   
@@ -41,4 +44,5 @@
     ALLOCATE(bps(nlayer))
     ALLOCATE(presnivs(nlayer))
+    ALLOCATE(presinter(nlayer+1))
     ALLOCATE(pseudoalt(nlayer))
   
@@ -50,4 +54,5 @@
     bps(:) = bps_(:)
     presnivs(:) = presnivs_(:)
+    presinter(:) = presinter_(:)
     pseudoalt(:) = pseudoalt_(:)
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phydev/infotrac_phy.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phydev/infotrac_phy.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phydev/infotrac_phy.F90	(revision 4482)
@@ -4,23 +4,20 @@
 MODULE infotrac_phy
 
-! Information on tracers for physics;
-! nqtot : total number of tracers and higher order of moment, water vapor and liquid included
-  INTEGER, SAVE :: nqtot
-!$OMP THREADPRIVATE(nqtot)
-
-  CHARACTER(len=4),SAVE :: type_trac
-!$OMP THREADPRIVATE(type_trac)
+   USE strings_mod, ONLY: maxlen
+   INTEGER,                 SAVE :: nqtot                       !--- Tracers nb in dynamics (incl. higher moments + H2O)
+   CHARACTER(LEN=maxlen),   SAVE :: type_trac                   !--- Keyword for tracers type
+!$OMP THREADPRIVATE(nqtot, type_trac)
 
 CONTAINS
 
-  SUBROUTINE init_infotrac_phy(nqtot_,type_trac_)
-  ! transfer information on tracers from dynamics to physics
-  IMPLICIT NONE
-    INTEGER,INTENT(IN) :: nqtot_
-    CHARACTER(len=4),INTENT(IN) :: type_trac_
+SUBROUTINE init_infotrac_phy(nqtot_, type_trac_)
+   IMPLICIT NONE
+   INTEGER,          INTENT(IN) :: nqtot_
+   CHARACTER(LEN=*), INTENT(IN) :: type_trac_
+   CHARACTER(LEN=maxlen) :: modname='init_infotrac_phy'
 
-    nqtot=nqtot_
-    type_trac=type_trac_
-  
+   nqtot = nqtot_
+   type_trac = type_trac_
+
   END SUBROUTINE init_infotrac_phy
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/phys_output_write_spl_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/phys_output_write_spl_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/Dust/phys_output_write_spl_mod.F90	(revision 4482)
@@ -381,5 +381,5 @@
     USE pbl_surface_mod, ONLY: snow
     USE indice_sol_mod, ONLY: nbsrf
-    USE infotrac, ONLY: nqtot, nbtr, tracers, type_trac
+    USE infotrac, ONLY: nqtot, nbtr, tracers
     USE geometry_mod, ONLY: cell_area
     USE surface_data, ONLY: type_ocean, version_ocean, ok_veget, landice_opt
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/calcaerosolstrato_rrtm.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/calcaerosolstrato_rrtm.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/calcaerosolstrato_rrtm.F90	(revision 4482)
@@ -16,5 +16,4 @@
   INCLUDE "clesphys.h"
   INCLUDE "paramet.h"
-  INCLUDE "thermcell.h"
   INCLUDE "iniprint.h"
 
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/micphy_tstep.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/micphy_tstep.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/micphy_tstep.F90	(revision 4482)
@@ -7,5 +7,5 @@
   USE dimphy, ONLY : klon,klev
   USE aerophys
-  USE infotrac_phy
+  USE infotrac_phy, ONLY : nbtr_bin, nbtr_sulgas, nbtr, id_H2SO4_strat
   USE phys_local_var_mod, ONLY: mdw, budg_3D_nucl, budg_3D_cond_evap, budg_h2so4_to_part, R2SO4, DENSO4, f_r_wet
   USE nucleation_tstep_mod
@@ -47,5 +47,5 @@
   REAL ASO4(nbtr_bin)
   REAL DNDR(nbtr_bin)
-  REAL H2SO4_sat(nbtr_bin)
+  REAL H2SO4_sat
 
   DO it=1,nbtr_bin
@@ -107,4 +107,6 @@
              & ACTSO4(ilon,ilev),R2SO4(ilon,ilev),DENSO4(ilon,ilev),f_r_wet(ilon,ilev), &
              & RRSI,Vbin,FL,ASO4,DNDR)
+      ! Compute H2SO4 saturate vapor for big particules
+      H2SO4_sat = DNDR(nbtr_bin)/(pplay(ilon,ilev)/t_seri(ilon,ilev)/RD/1.E6/mH2SO4mol)
       ! consider only condensation (positive FL)
       DO it=1,nbtr_bin
@@ -117,5 +119,5 @@
       ENDDO
       ! determine appropriate time step
-      dt=(H2SO4_init-H2SO4_sat(nbtr_bin))/float(nbtstep)/MAX(1.e-30, nucl_rate+cond_evap_rate) !cond_evap_rate pos. for cond. and neg. for evap.
+      dt=(H2SO4_init-H2SO4_sat)/float(nbtstep)/MAX(1.e-30, nucl_rate+cond_evap_rate) !cond_evap_rate pos. for cond. and neg. for evap.
       IF (dt.LT.0.0) THEN
         dt=PDT
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/nucleation_tstep_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/nucleation_tstep_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/nucleation_tstep_mod.F90	(revision 4482)
@@ -604,5 +604,5 @@
      na_n=x_n*ntot_n
      IF (na_n .LT. 1.) THEN
-        print *, 'Warning: number of acid molecules < 1 in nucleation regime, setting na_n=1'
+!        print *, 'Warning: number of acid molecules < 1 in nucleation regime, setting na_n=1'
         na_n=1.0
      ENDIF
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/strataer_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/strataer_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/strataer_mod.F90	(revision 4482)
@@ -79,5 +79,6 @@
     !Config Help = Used in physiq.F
     !
-    flag_sulf_emit = 0
+    flag_sulf_emit = 0 ! Background (default)
+    flag_sulf_emit_distrib = 0 ! Gaussian (default)
     nErupt = 0 ! eruption number
     injdur = 0 ! init injection duration
@@ -87,4 +88,31 @@
        CALL getin_p('nErupt',nErupt)
        CALL getin_p('injdur',injdur)
+       CALL getin_p('flag_sulf_emit_distrib',flag_sulf_emit_distrib)
+
+       year_emit_vol=0 ; mth_emit_vol=0 ; day_emit_vol=0
+       m_aer_emiss_vol=0. ; altemiss_vol=0. ; sigma_alt_vol=0.
+       xlon_min_vol=0. ; xlon_max_vol=0.
+       xlat_min_vol=0. ; xlat_max_vol=0.
+
+       IF (nErupt.GT.0) THEN
+          ALLOCATE(year_emit_vol(nErupt),mth_emit_vol(nErupt),day_emit_vol(nErupt))
+          ALLOCATE(m_aer_emiss_vol(nErupt),altemiss_vol(nErupt),sigma_alt_vol(nErupt))
+          ALLOCATE(xlat_min_vol(nErupt),xlon_min_vol(nErupt))
+          ALLOCATE(xlat_max_vol(nErupt),xlon_max_vol(nErupt))
+       ELSE
+          WRITE(lunout,*) 'ERROR : Using flag_sulf_emit=1 (ie Volcanic eruption) but nErupt (',nErupt,') <=0 !'
+          CALL abort_physic('strataer_mod','No eruption define in physiq_def (nErupt=0). Add one or use background condition.',1)
+       ENDIF
+
+       CALL getin_p('year_emit_vol',year_emit_vol)
+       CALL getin_p('mth_emit_vol',mth_emit_vol)
+       CALL getin_p('day_emit_vol',day_emit_vol)
+       CALL getin_p('m_aer_emiss_vol',m_aer_emiss_vol)
+       CALL getin_p('altemiss_vol',altemiss_vol)
+       CALL getin_p('sigma_alt_vol',sigma_alt_vol)
+       CALL getin_p('xlon_min_vol',xlon_min_vol)
+       CALL getin_p('xlon_max_vol',xlon_max_vol)
+       CALL getin_p('xlat_min_vol',xlat_min_vol)
+       CALL getin_p('xlat_max_vol',xlat_max_vol)
     ELSEIF (flag_sulf_emit == 2) THEN ! SAI
        CALL getin_p('m_aer_emiss_sai',m_aer_emiss_sai)
@@ -93,5 +121,4 @@
        CALL getin_p('xlat_sai',xlat_sai)
        CALL getin_p('xlon_sai',xlon_sai)
-       CALL getin_p('flag_sulf_emit_distrib',flag_sulf_emit_distrib)
     ELSEIF (flag_sulf_emit == 3) THEN ! SAI between latitudes
        CALL getin_p('m_aer_emiss_sai',m_aer_emiss_sai)
@@ -101,29 +128,6 @@
        CALL getin_p('xlat_max_sai',xlat_max_sai)
        CALL getin_p('xlat_min_sai',xlat_min_sai)
-       CALL getin_p('flag_sulf_emit_distrib',flag_sulf_emit_distrib)
     ENDIF
 
-    ALLOCATE(year_emit_vol(nErupt),mth_emit_vol(nErupt),day_emit_vol(nErupt))
-    ALLOCATE(m_aer_emiss_vol(nErupt),altemiss_vol(nErupt),sigma_alt_vol(nErupt))
-    ALLOCATE(xlat_min_vol(nErupt),xlon_min_vol(nErupt))
-    ALLOCATE(xlat_max_vol(nErupt),xlon_max_vol(nErupt))
-    
-    IF (nErupt.GT.0) THEN 
-      year_emit_vol=0 ; mth_emit_vol=0 ; day_emit_vol=0
-      m_aer_emiss_vol=0. ; altemiss_vol=0. ; sigma_alt_vol=0.
-      xlon_min_vol=0. ; xlon_max_vol=0.
-      xlat_min_vol=0. ; xlat_max_vol=0.
-    ENDIF
-    
-    CALL getin_p('year_emit_vol',year_emit_vol)
-    CALL getin_p('mth_emit_vol',mth_emit_vol)
-    CALL getin_p('day_emit_vol',day_emit_vol)
-    CALL getin_p('m_aer_emiss_vol',m_aer_emiss_vol)
-    CALL getin_p('altemiss_vol',altemiss_vol)
-    CALL getin_p('sigma_alt_vol',sigma_alt_vol)
-    CALL getin_p('xlon_min_vol',xlon_min_vol)
-    CALL getin_p('xlon_max_vol',xlon_max_vol)
-    CALL getin_p('xlat_min_vol',xlat_min_vol)
-    CALL getin_p('xlat_max_vol',xlat_max_vol)
     !Config Key  = flag_nuc_rate_box
     !Config Desc = define or not a box for nucleation rate
@@ -136,4 +140,7 @@
     !
     flag_nuc_rate_box = .FALSE.
+    nuclat_min=0  ; nuclat_max=0
+    nucpres_min=0 ; nucpres_max=0
+
     CALL getin_p('flag_nuc_rate_box',flag_nuc_rate_box)
     CALL getin_p('nuclat_min',nuclat_min)
@@ -153,5 +160,4 @@
        WRITE(lunout,*) 'IN STRATAER : altemiss_vol',altemiss_vol
        WRITE(lunout,*) 'IN STRATAER : sigma_alt_vol',sigma_alt_vol
-       WRITE(lunout,*) 'IN STRATAER : ponde_lonlat_vol',ponde_lonlat_vol
        WRITE(lunout,*) 'IN STRATAER : xlat_min_vol',xlat_min_vol
        WRITE(lunout,*) 'IN STRATAER : xlat_max_vol',xlat_max_vol
@@ -164,5 +170,4 @@
        WRITE(lunout,*) 'IN STRATAER : xlat_sai',xlat_sai
        WRITE(lunout,*) 'IN STRATAER : xlon_sai',xlon_sai
-       WRITE(lunout,*) 'flag_sulf_emit_distrib = ',flag_sulf_emit_distrib
     ELSEIF (flag_sulf_emit == 3) THEN
        WRITE(lunout,*) 'IN STRATAER : m_aer_emiss_sai',m_aer_emiss_sai
@@ -172,6 +177,6 @@
        WRITE(lunout,*) 'IN STRATAER : xlat_max_sai',xlat_max_sai
        WRITE(lunout,*) 'IN STRATAER : xlon_sai',xlon_sai
-       WRITE(lunout,*) 'flag_sulf_emit_distrib = ',flag_sulf_emit_distrib
     ENDIF
+    WRITE(lunout,*) 'flag_sulf_emit_distrib = ',flag_sulf_emit_distrib
     WRITE(lunout,*) 'IN STRATAER : flag_nuc_rate_box = ',flag_nuc_rate_box
     IF (flag_nuc_rate_box) THEN
@@ -181,6 +186,9 @@
     !ENDIF
 
-    CALL strataer_ponde_init
-    WRITE(lunout,*) 'IN STRATAER INT2 END'
+    IF (flag_sulf_emit == 1) THEN
+       CALL strataer_ponde_init
+       WRITE(lunout,*) 'IN STRATAER INT2 END'
+    END IF
+    WRITE(lunout,*) 'IN STRATAER END'
 
   END SUBROUTINE strataer_init
Index: LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/traccoag_mod.F90
===================================================================
--- LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/traccoag_mod.F90	(revision 4444)
+++ LMDZ6/branches/LMDZ_ECRad/libf/phylmd/StratAer/traccoag_mod.F90	(revision 4482)
@@ -17,5 +17,5 @@
 
     USE dimphy
-    USE infotrac_phy
+    USE infotrac_phy, ONLY : nbtr_bin, nbtr_sulgas, nbtr, id_SO2_strat
     USE aerophys
     USE geometry_mod, ONLY : cell_area, boundslat
@@ -23,5 +23,5 @@
     USE mod_phys_lmdz_mpi_data, ONLY :  is_mpi_root
     USE mod_phys_lmdz_para, only: gather, scatter
-    USE phys_cal_mod
+    USE phys_cal_mod, ONLY : year_len, year_cur,mth_cur, day_cur, hour
     USE sulfate_aer_mod
     USE phys_local_var_mod, ONLY: stratomask
@@ -29,5 +29,4 @@
     USE print_control_mod, ONLY: lunout
     USE strataer_mod
-    USE phys_cal_mod, ONLY : year_len
 
     IMPLICIT NONE
